---

stages:
  - build_bases
  - build_finals

### Job Templates (inherited/extended by actual jobs) ###

# All build jobs for each image built use/inherit/extend this template
.dl_docker_build_image:
  image:
    name: registry.gitlab.com/dreamer-labs/tsc/pipelines/docker-final:mr-12
  services:
    - docker:20-dind
  variables:
    TAG: "mr-${CI_MERGE_REQUEST_IID}"
  script:
    - /usr/bin/env bash /pipelines/docker/2.0.0/docker-build-images.sh

# This template is extended by base build jobs.
# Base images only include changes to system deps and other deps, but not code changes.
# It ensures base images are only rebuilt when there are changes to the Dockerfile for the image.
.dl_docker_base_image:
  stage: build_bases
  # This will run only on merge request and not on a branch.
  # We do this to avoid running duplicate pipelines.
  rules:
    - if: $CI_COMMIT_BRANCH
      when: never
    - if: $CI_MERGE_REQUEST_ID && $CI_COMMIT_MESSAGE =~ /^(feat:|fix:)/
      changes:
        - $DOCKERFILE

# This template is extended by final build jobs.
# Final builds only include code changes, and not changes to system packages and other deps.
.dl_docker_final_image:
  stage: build_finals
  # This will run only on merge request and not on a branch.
  # We do this to avoid running duplicate pipelines.
  rules:
    - if: $CI_COMMIT_BRANCH
      when: never
    - if: $MERGE_REQUEST_ID && $CI_COMMIT_MESSAGE =~ /^(feat:|fix:)/

...
